#!/usr/locl/bin/perl

package _irix;
sub IFF_UP {0x1;};
sub IFF_BROADCAST {0x2;};
sub IFF_DEBUG {0x4;};
sub IFF_LOOPBACK {0x8;};
sub IFF_POINTOPOINT {0x10;};
sub IFF_NOTRAILERS {0x20;};
sub IFF_RUNNING {0x40;};
sub IFF_NOARP {0x80;};
sub IFF_PROMISC {0x100;};
sub IFF_ALLMULTI {0x200;};
sub IFF_FILTMULTI {0x400;};
sub IFF_INTELLIGENT {0x400;};
sub IFF_MULTICAST {0x800;};
sub IFF_CKSUM {0x1000;};
sub IFF_ALLCAST {0x2000;};
sub IFF_PRIVATE {0x8000;};
sub IFF_CANTCHANGE {( &IFF_BROADCAST | &IFF_POINTOPOINT | &IFF_RUNNING | &IFF_MULTICAST | &IFF_FILTMULTI);};

sub IOCPARM_MASK {0xff;};
sub IOC_OUT {0x40000000;};
sub IOC_IN {0x80000000;};
sub IOC_INOUT {( &IOC_IN| &IOC_OUT);};
sub _IOC {
    local($f,$n,$x,$y) = @_;
    eval "((($f)|((($n)& &IOCPARM_MASK)<<16)|(($x)<<8)|($y)))";
};

sub _IOWR {
    local($x,$y,$t) = @_;
    eval " &_IOC( &IOC_INOUT, $t, $x, $y)";
};

sub _IOW {
    local($x,$y,$t) = @_;
    eval " &_IOC( &IOC_IN, $t, $x, $y)";
};

sub SIOCGIFFLAGS { &_IOWR(ord("i"),17, 32);};
sub SIOCSIFFLAGS { &_IOW(ord("i"),16, 32);};

sub login_chk {
    local($aname, $apass, $S) = @_;
    local($result);

    $aname .= "\r\n";
    $apass .= "\r\n";

    select($S); $| = 1; select(STDOUT);

# These are the negotiation packets.
# On an Indy running 5.3 the queries sent are
#
#     24 == \030 == Terminal type (RFC 1091)
#     32 == \040 == Terminal-speed (RFC 1079)
#     35 == \043 == X-Display-location (RFC 1096)
#     36 == \044 == Environ (RFC 1408 and 1571)
#
# Supposedly, we don't have to answer the queries (RFC 854) because the
# defaults are 
#
#     252 == \374 == WON'T
#     254 == \376 == DON'T.
#
# All queries and respnses are prefaced by 255 == \377 == IAC.

    recv($S, $result, 128, 0);
    $result =~ s/\375/\374/g;
    $result =~ s/\373/\376/g;
    print $S $result;



    recv($S, $result, 128, 0);
    $result =~ s/\375/\374/g;
    $result =~ s/\373/\376/g;
    print $S $result;



    recv($S, $result, 9, 0);
    $result =~ s/\375/\374/g;
    $result =~ s/\373/\376/g;
    print $S $result;

    $result = "";

    $/ = ': ';
    while (<$S>) {
	last if /^login/;
    }

    $/ = '\n';

    $sent = send($S, $aname, 0);

    send ($S, $apass, 0);

    sleep 5;
    recv($S, $result, 1024, 0);

    $result =~ s/\n/\n\t/g;
    $result = "\n\t" . $result;
    $result .= "\n\n";

    print $result;

    return $result;
}

1;
